package com.qmth.cqb.paper.web;

import cn.com.qmth.examcloud.common.uac.annotation.Uac;
import cn.com.qmth.examcloud.common.uac.entity.AccessUser;
import cn.com.qmth.examcloud.common.uac.enums.RoleMeta;
import cn.com.qmth.examcloud.common.uac.enums.UacPolicy;
import io.swagger.annotations.ApiOperation;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeansException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;

import com.qmth.cqb.paper.dao.ExportServiceManageRepo;
import com.qmth.cqb.paper.model.ExportServiceManage;
import com.qmth.cqb.paper.service.export.DzkdExportPaperService;
import com.qmth.cqb.paper.service.export.ExportPaperAbstractService;
import com.qmth.cqb.paper.service.export.ExportPaperService;

import java.lang.reflect.Method;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Created by songyue on 17/3/30.
 */
@Controller
@RequestMapping("${api_cqb}/")
public class ExportPaperController {

    protected static final Logger log = LoggerFactory.getLogger(ExportPaperController.class);
    
    
    @Autowired
    ExportServiceManageRepo exportServiceManageRepo; 
    
    @Autowired
    ExportPaperAbstractService exportPaperService;

    /**
     * 导出试卷
     * @param id
     * @return
     */
    @ApiOperation(value="导出试卷",notes="导出试卷")
    @Uac(roles={RoleMeta.QUESTION_ADMIN,RoleMeta.SUPER_ADMIN},policy=UacPolicy.IN)
    @GetMapping(value = "/paper/export/{id}")
    public void getPaperById(@PathVariable String id, HttpServletResponse response,HttpServletRequest request){
        log.info("导出开始");
        try {
            //AccessUser user = (AccessUser) request.getAttribute("accessUser");
            ExportServiceManage esm = exportServiceManageRepo.findByOrgName("电子科技大学");        
            Method mds[] = ExportPaperAbstractService.class.getDeclaredMethods(); 
            for(Method met:mds){ 
	            if(met.getName().equals(esm.getExportServiceName())){ 
		            met.invoke(exportPaperService, id,response); 
	            } 
            } 
        } catch (Exception e) {
            e.printStackTrace();
            log.error("导出异常:"+e.getMessage());
        }finally {
            log.info("导出结束");
        }
    }


}
